module Main( main ) where

import System.IO
import Control.Concurrent
import Control.Concurrent.Chan

type Pipe = Chan (Either Int Int)

someTime = 333

main =  do
        chan          <- newChan :: IO Pipe
        llist         <- getChanContents chan
        oddThread     <- forkIO ( printnumber_proc "odd:  " (catOdd  llist) )
        evenThread    <- forkIO ( printnumber_proc "even: " (catEven llist) )
        numbersThread <- forkIO ( numbers chan [1..] )
        waitForQ
        
        where
          printnumber_proc name (x:xs) = hPutStr stdout name >> hPutStrLn stdout (show x) >> printnumber_proc name xs
          catOdd  ls = [x | Left  x <- ls]
          catEven ls = [x | Right x <- ls]

numbers chan (x:xs) =
      if odd x
        then writeChan chan (Left  x) >> threadDelay someTime >> numbers chan xs
        else writeChan chan (Right  x) >> threadDelay someTime >> numbers chan xs

waitForQ = do
            c <- hGetChar stdin
            if c == 'q' 
              then return()
              else waitForQ
